{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
{% endblock begin_javascript_fix %}



{% block begin_javascript %}
{{ parent() }}
    {{ modulename }}Obj.prototype = {
        colDataMap : ['gRight', 'aRight', 'uRight', 'dRight', 'uOwnRight', 'dOwnRight'],
        formConfig: {
            items: [
                new mj.form.field({
                    dataIndex: 'id',
                    hidden: true
                }),
                //new mj.form.field({
                //    dataIndex: 'version',
                //    hidden: true
                //}),
                new mj.form.textField({
                    title: "{{ 'User.username'|trans }}",
                    dataIndex: 'username',
                    maxLength: 100,
                    notEmpty: true,
                    labelWidth : '110px',
                    grid: 'col s12 m6'
                }),
                new mj.form.textField({
                    title: "{{ 'User.fullname'|trans }}",
                    dataIndex: 'fullname',
                    maxLength: 100,
                    labelWidth : '110px',
                    grid: 'col s12 m6'
                }),
                new mj.form.textField({
                    title: "{{ 'User.email'|trans }}",
                    dataIndex: 'email',
                    maxLength: 100,
                    labelWidth : '110px',
                    grid: 'col s12 m6'
                }),
                new mj.form.passField({
                    title: "{{ 'User.password'|trans }}",
                    dataIndex: 'password',
                    maxLength: 100,
                    grid: 'col s12 m6',
                    labelWidth : '110px',
                    required : false
                })
            ]
        },
        gridConfig : {
            cm: [
    			{header: mj.lng.glb.id, dataIndex: 'id', width: 50, align:'right'},
    			{header: "{{ 'User.username'|trans }}", dataIndex: 'username', width: 200,filter:'single',alias:'u',operator:'%.%'},
    			{header: "{{ 'User.fullname'|trans }}", dataIndex: 'fullname', width: 200,filter:'single',alias:'u',operator:'%.%'},
    			{header: "{{ 'User.email'|trans }}", dataIndex: 'email', width: 200, filter:'single',alias:'u',operator:'%.%'}
    		]
        },
        _getRowExistingData : function(menuId) {
            var t = this;
            for(var i in t._backupTreeData){
                if(t._backupTreeData[i]["id"] == menuId)
                    return t._backupTreeData[i];
                if("children" && t._backupTreeData[i]["children"])
                    for(var j in t._backupTreeData[i]["children"]){
                        if(t._backupTreeData[i]["children"][j]["id"] == menuId)
                            return t._backupTreeData[i]["children"][j];
                    }
            }
            return null;
        },
        _modified : function(row){
            var t = this, existing = t._getRowExistingData(row.id);
            return (
                (row.data.gRight != row.data.gRight_backup && typeof row.data.gRight_backup != 'undefined' ) ||
                (row.data.aRight != row.data.aRight_backup && typeof row.data.aRight_backup != 'undefined' ) ||
                (row.data.dRight != row.data.dRight_backup && typeof row.data.dRight_backup != 'undefined' ) ||
                (row.data.uRight != row.data.uRight_backup && typeof row.data.uRight_backup != 'undefined' ) ||
                (row.data.dOwnRight != row.data.dOwnRight_backup && typeof row.data.dOwnRight_backup != 'undefined' ) ||
                (row.data.uOwnRight != row.data.uOwnRight_backup && typeof row.data.uOwnRight_backup != 'undefined' )
            );
        },
        getTreeData : function(data){
            var t = this, postData = [];
            for(var i = 0; i<data.length; i++){
                var m = data[i];
                if(m.children){
                    postData = postData.concat(t.getTreeData(m.children));
                } else if (t._modified(m)) {
                    postData.push({
                        menu_id : m.id,
                        user_right_id : m.user_right_id,
                        version : m.version,
                        gRight: m.data.gRight,
                        aRight: m.data.aRight,
                        dRight: m.data.dRight,
                        uRight: m.data.uRight,
                        dOwnRight: m.data.dOwnRight,
                        uOwnRight: m.data.uOwnRight
                    });
                }
            }
            return postData;
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);
            t.tabPanels.main.addTab({closable: false});
            t.tabs.main.userRights = t.tabPanels.main.tabs[2];
            t.panelRightsTree=new mj.panel({
                renderTo : t.tabs.main.userRights.getBody()
                ,border : false
                ,buttons : [
                    {alt: mj.lng.glb.save, cls: 'btn-sm left', iconCls: 'mj-save', scope: t, handler: t._onButtonFormSubmit1Click},
                    {alt: mj.lng.glb.cancel,cls: 'btn-sm left', iconCls: 'mj-list', scope: t, handler: t._onButtonFormCancel1Click}
                ]
            });
            t.on('activate-tab-user-rights', t._onActivateTabUserRights);
            t.tabPanels.main.setActive(1);
        },
        _onButtonFormCancel1Click: function() {
            this.reset();
            this.activateTabGrid();
        },
        _onButtonFormSubmit1Click: function() {
            this.save();
        },
        _onButtonEditUserRightsClick : function(){
            this.activateTabUserRights();
        },
        _onActivateTabUserRights:function(){
            var t = this;
            var selectedRecord = t.getSelectedRecord();
            if(selectedRecord && selectedRecord.rights){
                //var renderer = function(val){
                //    return t.treeCheckRenderer(val);
                //};
                if(!t.menuTree){
                    t.menuTree = new mj.tree({
                        renderTo :t.panelRightsTree.getBody(),
                        expanded : true,
		                mode : 'local',
                        store : new mj.store({
                            data: selectedRecord.rights
                        }),
                        cm: [
                            {width: 350, header: "&nbsp;"},
                            {value: "gRight", renderer:mj.renderer.check(), header: "{{ 'User.gRight'|trans }}", width: 70},
                            {value: "aRight", renderer:mj.renderer.check(), header: "{{ 'User.aRight'|trans }}", width: 70},
                            {value: "uRight", renderer:mj.renderer.check(), header: "{{ 'User.uRight'|trans }}", width: 70},
                            {value: "dRight", renderer:mj.renderer.check(), header: "{{ 'User.dRight'|trans }}", width: 70},
                            {value: "uOwnRight", renderer:mj.renderer.check(), header: "{{ 'User.uOwnRight'|trans }}", width: 70},
                            {value: "dOwnRight", renderer:mj.renderer.check(), header: "{{ 'User.dOwnRight'|trans }}", width: 70}
                        ]
                    });
                    t.menuTree.on('cellclick',function(tree, node, cell, colIndex){
                        if(colIndex>0){
                            var el = cell;
                            var chEl = el.find('div.mj-checkbox');
                            var obj = node;
                        }
                        var dataIndex = t.colDataMap[colIndex-1];
                        if(typeof obj.data[dataIndex+'_backup'] == 'undefined'){
                            obj.data[dataIndex+'_backup'] = obj.data[dataIndex];
                        }
                        if(obj.data[dataIndex]==0){
                            obj.data[dataIndex]=1;
                            chEl.addClass('mj-checkbox-checked');
                            if(colIndex>1){
                                if(typeof obj.data[t.colDataMap[0]+'_backup'] == 'undefined'){
                                    obj.data[t.colDataMap[0]+'_backup'] = obj.data[t.colDataMap[0]];
                                }
                                $("div[name='c-col-1']",node.el).find('div.mj-checkbox').addClass('mj-checkbox-checked');
                                obj.data[t.colDataMap[0]]=1;
                            }
                        }else{
                            obj.data[dataIndex]=0;
                            chEl.removeClass('mj-checkbox-checked');
                            if(colIndex==1){
                                for(var i=0;i<t.colDataMap.length;i++){
                                    if(typeof obj.data[t.colDataMap[i]+'_backup'] == 'undefined'){
                                        obj.data[t.colDataMap[i]+'_backup'] = obj.data[t.colDataMap[i]];
                                    }
                                    obj.data[t.colDataMap[i]]=0;
                                    $("div[name='c-col-"+(i+1)+"']",node.el).find('div.mj-checkbox').removeClass('mj-checkbox-checked');
                                }
                            }
                        }
                    });
                    t.menuTree.store.load();
                } else {
                    //t._unBindParentReference(selectedRecord.rights);
                    t.menuTree.store.data = selectedRecord.rights;
                    t.menuTree.store.load();
                }
            }
        },
        activateTabUserRights : function(){
            this.tabs.main.userRights.activate();
            //this.trigger('activate-tab-user-rights');
            this._onActivateTabUserRights();
        },
        _onMainGridRowClick: function(grid, rowIndex){
            this.buttons.editUserRights.setEnable();
            {{ modulename }}Obj.superclass._onMainGridRowClick.call(this);
        },
        _onMainStoreLoad : function(){
            var t = this;
            t.buttons.editUserRights.setDisable();
            {{ modulename }}Obj.superclass._onMainStoreLoad.call(t);
        },
        initDefaultButtons : function(){
            var t = this;
            {{ modulename }}Obj.superclass.initDefaultButtons.call(t);
            t.buttons.editUserRights = t.grids.main.pbar.tbar.addButton({alt: "{{ 'User.rights'|trans }}", cls:'left', iconCls: 'mj-lock', disabled: true, scope: t, handler: t._onButtonEditUserRightsClick});
        },
        reset : function(_forms, _data){
            var t = this;
            {{ modulename }}Obj.superclass.reset.call(t, _forms, _data);
    	},
        save : function(){
            var t = this, selectedRecord = t.getSelectedRecord();
            if(t.tabs.main.form.active){
                {{ modulename }}Obj.superclass.save.call(t);
            } else if(t.tabs.main.userRights.active){
                var routeName = '{{ modulename }}-update';
                var route = Routing.getRoute(routeName);
                var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                    'pg': t.grids.main.pbar.current,
                    'lm': t.grids.main.pbar.limit
                } : {};
                var url = Routing.generate(routeName, mj.apply(pagerParams, {
                    'id': selectedRecord.id,
                    'v': selectedRecord.version
                }));

                if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                    t.rolesToDelete = [];
                    //for(var i=0; i<t.assignedRolesBackup.length; i++){
                    //    if(t.assignedRoles.indexOf(t.assignedRolesBackup[i].roleId) == -1){
                    //        t.rolesToDelete.push(t.assignedRolesBackup[i]);
                    //    }
                    //}
                    t.rolesToInsert = [];
                    //for(var i=0; i<t.assignedRoles.length; i++){
                    //    if(mj.getIndex(t.assignedRolesBackup, 'roleId', t.assignedRoles[i]) == -1){
                    //        t.rolesToInsert.push(t.assignedRoles[i]);
                    //    }
                    //}

                    t.waitMaskShow();
                    $.ajax({
                        url: url,
                        method: "POST",
                        headers: { 
                            "Content-Type": "application/json",
                            "X-HTTP-Method-Override": route.methods[0]
                        },
                        data: JSON.stringify({rolesToInsert: t.rolesToInsert, rolesToDelete: t.rolesToDelete, userRights: t.getTreeData(t.menuTree.store.data),menuId:t.id}),
                        dataType: 'json',
                        success: function(data, textStatus, jqXHR) {
                            t.reset(t.forms, data);
                            t.activateTabGrid();
                        },
                        error: function(jqXHR, textStatus, errorThrown) {
                            mj.message({
                                title: mj.lng.glb.error,
                                msg: jqXHR.responseJSON.message,
                                type: "error",
                                html: true
                            });
                        },
                        complete: function(jqXHR, textStatus) {
                            t.waitMaskHide();
                        }
                    });
                }
            }
        }
    };
{% endblock begin_javascript %}



{% block begin_default_module %}
{{ parent() }}
{% endblock begin_default_module %}



{% block end_default_module %}
{{ parent() }}
{% endblock end_default_module %}


{% block end_javascript %}
{{ parent() }}
{% endblock end_javascript %}


{% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
{{ parent() }}
{% endblock body %}
